<img src="img/graphamole-logo.svg" alt="Graphamole logo: An molecular structure graph with a stylized avocado" width="320" />

# Graphamole

Molecular embeddings by masked graph modeling.

## About

Graphamole (_pronounced like guacamole_) is a Python package for generating molecular embeddings using masked graph modeling. It is built with [RDKit](https://www.rdkit.org/), [PyTorch](https://pytorch.org/), and [PyTorch Geometric](https://pytorch-geometric.readthedocs.io/). New molecular embeddings can be generated by training a masked graph model on any list of SMILES strings. The embeddings can be used for various downstream tasks, such as clustering, classification, and regression.

Graphamole was designed to embed amino acid residues for downstream tasks in mass spectrometry-based proteomics. Nevertheless, it can be used for any type of molecular data.


## Installation

Graphamole can be installed using pip:

```bash
pip install graphamole
```

For GPU support, install PyTorch with CUDA support. For instance:

```bash
pip install torch --index-url https://download.pytorch.org/whl/cu126
```

See the [PyTorch website](https://pytorch.org/get-started/locally/) for more information.


## Usage

Graphamole can be used through the command line interface (CLI) or as through the Python API. Currently, the CLI supports two usage modes: `train` and `embed`. Run `graphamole --help` for a list all options and arguments.

For a full overview of the Python API, checkout [graphamole.readthedocs.io](https://graphamole.readthedocs.io/).

## Contributing

We welcome all contributions to the project. Visit the [Contributing page](https://graphamole.readthedocs.io/en/latest/contributing/) to get started.
